import numpy as np
from math import *
import matplotlib
import matplotlib.pyplot as plt
import matplotlib.gridspec as gridspec
import sys, random, time
from mpl_toolkits.axes_grid1.inset_locator import zoomed_inset_axes
from mpl_toolkits.axes_grid1.inset_locator import mark_inset
from mpl_toolkits.axes_grid1.inset_locator import inset_axes

CVR_mean=np.array(np.loadtxt("centralized_constraint_violation_mean_file.txt",dtype=float))
CVR_mean1=np.array(np.loadtxt("learner1_constraint_violation_mean_file.txt",dtype=float))
CVR_mean2=np.array(np.loadtxt("learner2_constraint_violation_mean_file.txt",dtype=float))
CVR_mean3=np.array(np.loadtxt("learner3_constraint_violation_mean_file.txt",dtype=float))
CVR_mean4=np.array(np.loadtxt("learner4_constraint_violation_mean_file.txt",dtype=float))
#CVR_mean_follow=np.array(np.loadtxt("follow_constraint_violation_mean_file.txt",dtype=float))
#CVR_mean_double=np.array(np.loadtxt("double_constraint_violation_mean_file.txt",dtype=float))
#CVR_mean_greedy=np.array(np.loadtxt("greedy_constraint_violation_mean_file.txt",dtype=float))
CVR_sd=np.array(np.loadtxt("centralized_constraint_violation_sd_file.txt",dtype=float))
CVR_sd1=np.array(np.loadtxt("learner1_constraint_violation_sd_file.txt",dtype=float))
CVR_sd2=np.array(np.loadtxt("learner2_constraint_violation_sd_file.txt",dtype=float))
CVR_sd3=np.array(np.loadtxt("learner3_constraint_violation_sd_file.txt",dtype=float))
CVR_sd4=np.array(np.loadtxt("learner4_constraint_violation_sd_file.txt",dtype=float))
#CVR_sd_follow=np.array(np.loadtxt("follow_constraint_violation_sd_file.txt",dtype=float))
#CVR_sd_double=np.array(np.loadtxt("double_constraint_violation_sd_file.txt",dtype=float))
#CVR_sd_greedy=np.array(np.loadtxt("greedy_constraint_violation_sd_file.txt",dtype=float))

SR_mean=np.array(np.loadtxt("centralized_success_mean_file.txt",dtype=float))
SR_mean1=np.array(np.loadtxt("learner1_success_mean_file.txt",dtype=float))
SR_mean2=np.array(np.loadtxt("learner2_success_mean_file.txt",dtype=float))
SR_mean3=np.array(np.loadtxt("learner3_success_mean_file.txt",dtype=float))
SR_mean4=np.array(np.loadtxt("learner4_success_mean_file.txt",dtype=float))
#SR_mean_follow=np.array(np.loadtxt("follow_success_mean_file.txt",dtype=float))
#SR_mean_double=np.array(np.loadtxt("double_success_mean_file.txt",dtype=float))
#SR_mean_greedy=np.array(np.loadtxt("greedy_success_mean_file.txt",dtype=float))
SR_sd=np.array(np.loadtxt("centralized_success_sd_file.txt",dtype=float))
SR_sd1=np.array(np.loadtxt("learner1_success_sd_file.txt",dtype=float))
SR_sd2=np.array(np.loadtxt("learner2_success_sd_file.txt",dtype=float))
SR_sd3=np.array(np.loadtxt("learner3_success_sd_file.txt",dtype=float))
SR_sd4=np.array(np.loadtxt("learner4_success_sd_file.txt",dtype=float))
#SR_sd_follow=np.array(np.loadtxt("follow_success_sd_file.txt",dtype=float))
#SR_sd_double=np.array(np.loadtxt("double_success_sd_file.txt",dtype=float))
#SR_sd_greedy=np.array(np.loadtxt("greedy_success_sd_file.txt",dtype=float))

plt.rcParams.update({'font.size': 14})
axis=np.arange(0,75,4)

fig, ax = plt.subplots()
ax.plot(axis,CVR_mean,'-')
ax.fill_between(axis,CVR_mean-CVR_sd,CVR_mean+CVR_sd,alpha=0.2)
ax.plot(axis,CVR_mean1,'--')
ax.fill_between(axis,CVR_mean1-CVR_sd1,CVR_mean1+CVR_sd1,alpha=0.2)
ax.plot(axis,CVR_mean2,'-.')
ax.fill_between(axis,CVR_mean2-CVR_sd2,CVR_mean2+CVR_sd2,alpha=0.2)
ax.plot(axis,CVR_mean3,'--')
ax.fill_between(axis,CVR_mean3-CVR_sd3,CVR_mean3+CVR_sd3,alpha=0.2)
ax.plot(axis,CVR_mean4,'-.')
ax.fill_between(axis,CVR_mean4-CVR_sd4,CVR_mean4+CVR_sd4,alpha=0.2)

#ax.plot(axis,CVR_mean_follow,':')
#ax.fill_between(axis,CVR_mean_follow-CVR_sd_follow,CVR_mean_follow+CVR_sd_follow,alpha=0.2)
#ax.plot(axis,CVR_mean_double,'.')
#ax.fill_between(axis,CVR_mean_double-CVR_sd_double,CVR_mean_double+CVR_sd_double,alpha=0.2)
#ax.plot(axis,CVR_mean_greedy,'<-')
#ax.fill_between(axis,CVR_mean_greedy-CVR_sd_greedy,CVR_mean_greedy+CVR_sd_greedy,alpha=0.2)
plt.xticks(np.arange(0,75,8))
plt.xlabel('Demonstrations')
plt.show()

fig, ax = plt.subplots()
ax.plot(axis,SR_mean,'-')
ax.fill_between(axis,SR_mean-SR_sd,SR_mean+SR_sd,alpha=0.2)
ax.plot(axis,SR_mean1,'--')
ax.fill_between(axis,SR_mean1-SR_sd1,SR_mean1+SR_sd1,alpha=0.2)
ax.plot(axis,SR_mean2,'-.')
ax.fill_between(axis,SR_mean2-SR_sd2,SR_mean2+SR_sd2,alpha=0.2)

ax.plot(axis,SR_mean3,'--')
ax.fill_between(axis,SR_mean3-SR_sd3,SR_mean3+SR_sd3,alpha=0.2)
ax.plot(axis,SR_mean4,'-.')
ax.fill_between(axis,SR_mean4-SR_sd4,SR_mean4+SR_sd4,alpha=0.2)
#ax.plot(axis,SR_mean_follow,':')
#ax.fill_between(axis,SR_mean_follow-SR_sd_follow,SR_mean_follow+SR_sd_follow,alpha=0.2)
#ax.plot(axis,SR_mean_double,'.')
#ax.fill_between(axis,SR_mean_double-SR_sd_double,SR_mean_double+SR_sd_double,alpha=0.2)
#ax.plot(axis,SR_mean_greedy,'<-')
#ax.fill_between(axis,SR_mean_greedy-SR_sd_greedy,SR_mean_greedy+SR_sd_greedy,alpha=0.2)
plt.xticks(np.arange(0,75,8))
plt.xlabel('Demonstrations')
plt.show()






